using System;

namespace MikuMikuDance.XNA.Stages
{
    /// <summary>
    /// モーションファイルからカメラモーションを再生するアニメーションプレイヤー
    /// </summary>
    public class CameraAnimationPlayer
    {
        //現在のモーション一覧
        CameraMotionTrack[] mmdMotion = new CameraMotionTrack[MikuMikuDanceXNA.MotionTrackCap];

        /// <summary>
        /// 一秒あたりのフレーム数
        /// </summary>
        public int FramePerSecond { get; set; }
        

        internal CameraAnimationPlayer()
        {
            FramePerSecond = 30;//MMDは30フレーム/秒が標準
            for (int i = 0; i < mmdMotion.Length; i++)
                mmdMotion[i] = new CameraMotionTrack();
        }
        /// <summary>
        /// モーションをリセットする
        /// </summary>
        /// <param name="index">モーショントラック番号</param>
        public void Reset(int index)
        {
            mmdMotion[index].Reset();
        }
        /// <summary>
        /// モーションがループプレイかどうかを調べる
        /// </summary>
        /// <param name="index">モーショントラック番号</param>
        /// <returns>ループプレイならtrue</returns>
        public bool IsLoopPlay(int index)
        {
            return mmdMotion[index].IsLoopPlay;
        }
        /// <summary>
        /// モーションの再生状態を取得
        /// </summary>
        /// <param name="index">モーショントラック番号</param>
        /// <returns>再生中ならtrue</returns>
        public bool IsPlay(int index)
        {
            return (mmdMotion[index].IsPlay);
        }

        /// <summary>
        /// 開いているトラックにモーションをセット
        /// </summary>
        /// <param name="index">トラック番号(0〜MikuMikuDanceXNA.MotionTrackCap)</param>
        /// <param name="motion">セットするMMDステージモーションデータ</param>
        /// <param name="SetStartPos">0フレームのデータでカメラを初期化する</param>
        /// <param name="camera">カメラ</param>
        /// <returns>セットしたトラックの番号。開いているトラックが無ければ-1</returns>
        public void SetMotion(int index, MMDStageMotion motion, bool SetStartPos, IMMDCamera camera)
        {
            if (motion.MotionData.CameraMotions.Length == 0)
                throw new ApplicationException("カメラモーションが含まれていません");
            //オブジェクトプールのモーショントラックにデータをセット
            mmdMotion[index].Clear();
            motion.ToCameraUse = true;
            mmdMotion[index].motion = motion;
            mmdMotion[index].IsEmpty = false;
            mmdMotion[index] = mmdMotion[index];//オブジェクトプールから引っ張ってくる
            if (SetStartPos)
                Update(index, true, camera);
        }

        /// <summary>
        /// 空いたトラックにモーションをセット
        /// </summary>
        /// <param name="motion">セットするMMDモーションデータ</param>
        /// <param name="SetStartPos">0フレームのデータでカメラを初期化する</param>
        /// <param name="camera">カメラ</param>
        /// <returns>セットされたトラック番号</returns>
        public int SetMotion(MMDStageMotion motion, bool SetStartPos, IMMDCamera camera)
        {
            int Index = -1;
            for (Index = 0; Index < MikuMikuDanceXNA.MotionTrackCap; Index++)
                if (mmdMotion[Index].IsEmpty)
                    break;
            if (Index >= MikuMikuDanceXNA.MotionTrackCap)
                return -1;
            SetMotion(Index, motion, SetStartPos, camera);
            return Index;
        }
        /// <summary>
        /// モーションを再生する
        /// </summary>
        /// <param name="index">モーションインデックス番号</param>
        /// <param name="bLoopPlay">ループプレイ</param>
        public void Start(int index, bool bLoopPlay)
        {
            if (mmdMotion[index].IsEmpty)
                throw new ApplicationException("モーションデータがセットされてないのにStartを実行した");
            mmdMotion[index].Start();
            mmdMotion[index].IsLoopPlay = bLoopPlay;
        }
        /// <summary>
        /// モーションをストップする
        /// </summary>
        public void Stop(int index)
        {
            mmdMotion[index].Stop();
        }

        internal void Update(int motionIndex, bool ForceUpdate, IMMDCamera camera)
        {
            for (int i = (motionIndex < 0 ? 0 : motionIndex); i < (motionIndex < 0 ? mmdMotion.Length : motionIndex + 1); i++)
            {
                //再生中かどうかチェック
                if ((!mmdMotion[i].IsEmpty && mmdMotion[i].IsPlay) || ForceUpdate)
                {
                    //現在の再生フレームを更新
                    mmdMotion[i].UpdateFrame(FramePerSecond);
                    mmdMotion[i].ApplyMotion(camera);
                }
            }
        }
    }
}